//----------------------------------------------------------------
// GUI main Frame - 2 Termometre med grafisk brugergrnseflade i 1 frame
// Programmr: Bjrk Busch nov.1999/2001
//----------------------------------------------------------------

import javabook.Convert;
import javabook.Format;
import java.awt.event.*;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.Button;
import java.awt.Label;
import java.awt.TextField;

public	class GuiMainFrame extends Frame
{
	// Skrmdata
	private JPanel      panel0        = new JPanel ();
	private JPanel      panel1        = new JPanel ();
	private JPanel      panel1a       = new JPanel ();
	private JPanel      panel1b       = new JPanel ();
	private JPanel      panel1c       = new JPanel ();
	private JPanel      panel2        = new JPanel ();
	private JPanel      panel2a       = new JPanel ();
	private JPanel      panel2b       = new JPanel ();
	private JPanel      panel3        = new JPanel ();

	private Label       labelAktuel   = new Label ("Aktuel temperatur:");
	private Label       labelMin      = new Label ("Minimum temperatur:");
	private Label       labelMax      = new Label ("Maksimum temperatur:");
	private TextField   aktuelt       = new TextField ("",30);
	private TextField   min           = new TextField ("",30);
	private TextField   max           = new TextField ("",30);
  private Choice      outEnhed      = new Choice();
  private Choice      outTermometerNavn	= new Choice();

  private Button      aflaes        = new Button ("Afls termometer");
  private Button      clear         = new Button ("Clear Min/Max");


  private Label       labelNyTemperatur	= new Label ("Ny temperaturmling:");
  private TextField   nyTemperatur      = new TextField ("",30);
  private Checkbox    inFahrenheit      = new Checkbox("Fahrenheit", null, false);
  private Choice      inEnhed           = new Choice();
  private Choice      inTermometerNavn	= new Choice();
  private Button      opdater           = new Button ("Opdater termometer");

  private Button      afslut            = new Button ("Aflut");


  //	Model-komponent
  private Termometer []	termometer      = { new Termometer(), new Termometer() };
  private String []     termometerNavn  = { "Indendrs", "Udendrs" };

	

	public GuiMainFrame ()			/* constructor */
	{
    // opbygning af skrmbillede
    setSize(600,400);
    setTitle("TermometerProgram");

    setLayout(new GridLayout(1,1));         
    panel0.setLayout(null);          
    add(panel0);

    panel1.setBounds(5,5,500,200);
    panel1.setBorder(new TitledBorder(new EtchedBorder(),"Termometer aflsning"));
    panel1.setLayout(new GridLayout(1,3));          
    panel0.add(panel1);

    panel1a.setLayout(new GridLayout(4,1));         
    panel1.add(panel1a);
    panel1a.add(labelAktuel);
    panel1a.add(labelMin);
    panel1a.add(labelMax);

    aktuelt.setEditable(false);
    aktuelt.setEnabled(false);
    min.setEditable(false);
    min.setEnabled(false);
    max.setEditable(false);
    max.setEnabled(false);

    panel1b.setLayout(new GridLayout(4,1));         
    panel1.add(panel1b);
    panel1b.add(aktuelt);
    panel1b.add(min);
    panel1b.add(max);
        outEnhed.addItem("Celcius");
        outEnhed.addItem("Fahrenheit");
        outEnhed.select(0);
    panel1b.add(outEnhed);

    panel1c.setLayout(new GridLayout(4,1));         
    panel1.add(panel1c);
    panel1c.add(aflaes);
    aflaes.addActionListener(new AflaesKnapActionListener());
    panel1c.add(clear);
    clear.addActionListener(new ClearKnapActionListener());
    panel1c.add(new Label (""));	// fyld
    for (int i = 0; i < termometerNavn.length; i++)
	        outTermometerNavn.addItem(termometerNavn[i]);
        outTermometerNavn.select(0);
    panel1c.add(outTermometerNavn);


    panel2.setBounds(5,215,500,150);
    panel2.setBorder(new TitledBorder(new EtchedBorder(),"Termometer opdatering"));
    panel2.setLayout(new GridLayout(1,2));          
    panel0.add(panel2);

    panel2a.setLayout(new GridLayout(3,1));         
    panel2.add(panel2a);
    panel2a.add(labelNyTemperatur);
    panel2a.add(nyTemperatur);
    inEnhed.addItem("Celcius");
    inEnhed.addItem("Fahrenheit");
    inEnhed.select(0);
    panel2a.add(inEnhed);

    panel2b.setLayout(new GridLayout(3,1));         
    panel2.add(panel2b);

    panel2b.add(new Label (""));	// fyld
    panel2b.add(opdater);
    opdater.addActionListener(new OpdaterKnapActionListener());

    for (int i = 0; i < termometerNavn.length; i++)
    {
        inTermometerNavn.addItem(termometerNavn[i]);
    }
    inTermometerNavn.select(0);
    panel2b.add(inTermometerNavn);

    panel3.setBounds(505,5,85,360);
    panel3.setBorder(new TitledBorder(new EtchedBorder()," "));
    panel3.setLayout(new GridLayout(10,1));          
    panel0.add(panel3);

    panel3.add(afslut);
    afslut.addActionListener(new AfslutKnapActionListener());

    setVisible(true);

	}

	private void aflaesTermometer ()
	{
	  Termometer term = termometer[outTermometerNavn.getSelectedIndex()];
	  Temperatur	tempakt = term.getTemperatur();
	  Temperatur	tempmin = term.getMinTemperatur();
	  Temperatur	tempmax = term.getMaxTemperatur();
	  if (((String)outEnhed.getSelectedItem()).equals("Fahrenheit"))
	  {
      aktuelt.setText(Format.rightAlign(30,3,tempakt.getFahrenheit()));
      min.setText(Format.rightAlign(30,3,tempmin.getFahrenheit()));
      max.setText(Format.rightAlign(30,3,tempmax.getFahrenheit()));
	  }
	  else
	  {
      aktuelt.setText(Format.rightAlign(30,3,tempakt.getCelcius()));
      min.setText(Format.rightAlign(30,3,tempmin.getCelcius()));
      max.setText(Format.rightAlign(30,3,tempmax.getCelcius()));
	  }
	}

	private void clearTermometer ()
	{
	  Termometer term = termometer[outTermometerNavn.getSelectedIndex()];
	  term.clearMinMax();
	  aktuelt.setText("");
	  min.setText("");
	  max.setText("");
	}

	private void opdaterTermometer ()
	{
	  Termometer term = termometer[inTermometerNavn.getSelectedIndex()];
	  Temperatur	temp = new Temperatur();
	  if (((String)inEnhed.getSelectedItem()).equals("Fahrenheit"))
		  temp.setFahrenheit(Convert.toFloat(nyTemperatur.getText()));
	  else
		  temp.setCelcius(Convert.toFloat(nyTemperatur.getText()));
	  term.setTemperatur(temp);
	}


	private void luk ()
	{
	  System.exit(0);   // hvis Frame skal lukkes, men program ikke skal stoppes bruges
	                    // dispose();
	}

	private	class AfslutKnapActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
	  {
		  luk();
	  }
	}

	private	class AflaesKnapActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
      aflaesTermometer ();
		}
	}
	private	class ClearKnapActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
      clearTermometer ();
		}
	}
	
	private	class OpdaterKnapActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
      opdaterTermometer ();
		}
	}


} // slut p frame-klasse
